export interface RecipeFunctionHash {
    [ingredientKey: string]: () => string;
}
export interface RecipeVariant {
    display: string;
    ingredients: string[];
}
export interface RecipeVariantHash {
    [variantName: string]: RecipeVariant;
}
export interface Recipe {
    display: string;
    description?: string;
    variantOrder?: string[];
    variants: RecipeVariantHash;
}
export interface RecipeHash {
    [recipeName: string]: Recipe;
}
export interface GeneratorDefaultKeys {
    recipeKey: string;
    variantKey: string;
}
export interface RecipeDisplayInfo {
    key: string;
    display: string;
}
export interface VariantDisplayInfo {
    key: string;
    display: string;
}
export interface Cookbook {
    recipeOrder?: string[];
    recipes: RecipeHash;
}
export declare function BuildNameGenerator(cookbook: Cookbook): NameGenerator;
export interface NameGenerator {
    getRecipe: (recipeKey: string) => Recipe;
    getDefaultRecipeKey: () => string;
    getDefaultVariantKey: (recipeKey: string) => string;
    getDefaultKeys: () => GeneratorDefaultKeys;
    recipesForDisplay: () => RecipeDisplayInfo[];
    variantsForRecipe: (recipeKey: string) => VariantDisplayInfo[];
    makeName: (ingredientKey: string) => string;
    makeNames: (ingredientKey: string, count: number) => string[];
}
